#include "sokodan.h"
#include "MoveX.h"

MoveList search_moves (PositionPtr current)
{
  Coordinate  x, y;     /* Used for the current move */
  Direction   dir;
  Coordinate  xg, yg;   /* Where the gem would be pushed */
  Move        new_move;
  MoveList    moves;

  moves = MoveList_new ();

  for (x = 0; x < WIDTH; x++)
    for (y = 0; y < HEIGHT; y++)
      /* First, we check the case is accessible to the player */
      if ( CONTAIN (ACCESSIBLE, current->grid[ x ][ y ]) )
				for (dir = 0; dir < 4; dir++)
        {
          xg = x + 2 * Delta[ dir ].dx; /* xg is unsigned, so if it was to be negative, */
          yg = y + 2 * Delta[ dir ].dy; /* it will wrap and become a 255 or so... ;o)   */

          if (xg < WIDTH && yg < HEIGHT)
            /* The gem (if any) would stay in the grid */
          {
            if ( CONTAIN (GEM, current->grid[ x + Delta[dir].dx ][ y + Delta[dir].dy ])
                 && CAN_GO (current->grid[ xg ][ yg ]) )
              /* A gem, then an available case: that's a move! */
            {
              new_move.x = x;
              new_move.y = y;
              new_move.dir = dir;
              
              MoveList_add_Move (&moves, &new_move);
            }
          }
        }

  return moves;
}
