#ifndef _SOKODAN_H_
#define _SOKODAN_H_

#include <glib.h>
/* The code works! ;) */
/* #define G_DISABLE_ASSERT */

/* Gettext stuff */
#include "intl/libintl.h"
#define _(string) gettext (string)
/* End of Gettext stuff */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "sokoDan_config.h"
#include "types.h"

/* The attributes a case can hold */
#define BACKGROUND   1  /* 1 << 0 */
#define WALL         2  /* 1 << 1 */
#define GEM          4  /* 1 << 2 */
#define TARGET       8  /* 1 << 3 */
#define ACCESSIBLE  16  /* 1 << 4 */

/* Checks whether a case contains an attribute */
#define CONTAIN(thing, kase) ((kase) & (thing))

/* Adds an attribute on a case */
#define ADD(thing, kase)     ((kase) |= (thing))

/* Removes an attribute from a case */
#define REMOVE(thing, kase)  ((kase) &= ~(thing))

/* Checks wheter a player can be on the case */
#define CAN_GO(kase)         (!((kase) & (WALL | GEM)))


extern const delta Delta[ 4 ];

extern Position Problem;

typedef struct {
  gint        length;
	PositionPtr position; /* Will be actually Position[length] */
} tSolution;
extern tSolution Solution;


#endif /* _SOKODAN_H_ */
